package ecs

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeInstanceAttachmentAttributes invokes the ecs.DescribeInstanceAttachmentAttributes API synchronously
func (client *Client) DescribeInstanceAttachmentAttributes(request *DescribeInstanceAttachmentAttributesRequest) (response *DescribeInstanceAttachmentAttributesResponse, err error) {
	response = CreateDescribeInstanceAttachmentAttributesResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeInstanceAttachmentAttributesWithChan invokes the ecs.DescribeInstanceAttachmentAttributes API asynchronously
func (client *Client) DescribeInstanceAttachmentAttributesWithChan(request *DescribeInstanceAttachmentAttributesRequest) (<-chan *DescribeInstanceAttachmentAttributesResponse, <-chan error) {
	responseChan := make(chan *DescribeInstanceAttachmentAttributesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeInstanceAttachmentAttributes(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeInstanceAttachmentAttributesWithCallback invokes the ecs.DescribeInstanceAttachmentAttributes API asynchronously
func (client *Client) DescribeInstanceAttachmentAttributesWithCallback(request *DescribeInstanceAttachmentAttributesRequest, callback func(response *DescribeInstanceAttachmentAttributesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeInstanceAttachmentAttributesResponse
		var err error
		defer close(result)
		response, err = client.DescribeInstanceAttachmentAttributes(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeInstanceAttachmentAttributesRequest is the request struct for api DescribeInstanceAttachmentAttributes
type DescribeInstanceAttachmentAttributesRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	PageNumber           requests.Integer `position:"Query" name:"PageNumber"`
	PageSize             requests.Integer `position:"Query" name:"PageSize"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	InstanceIds          string           `position:"Query" name:"InstanceIds"`
}

// DescribeInstanceAttachmentAttributesResponse is the response struct for api DescribeInstanceAttachmentAttributes
type DescribeInstanceAttachmentAttributesResponse struct {
	*responses.BaseResponse
	PageSize   int                                             `json:"PageSize" xml:"PageSize"`
	RequestId  string                                          `json:"RequestId" xml:"RequestId"`
	PageNumber int                                             `json:"PageNumber" xml:"PageNumber"`
	TotalCount int                                             `json:"TotalCount" xml:"TotalCount"`
	Instances  InstancesInDescribeInstanceAttachmentAttributes `json:"Instances" xml:"Instances"`
}

// CreateDescribeInstanceAttachmentAttributesRequest creates a request to invoke DescribeInstanceAttachmentAttributes API
func CreateDescribeInstanceAttachmentAttributesRequest() (request *DescribeInstanceAttachmentAttributesRequest) {
	request = &DescribeInstanceAttachmentAttributesRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Ecs", "2014-05-26", "DescribeInstanceAttachmentAttributes", "ecs", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeInstanceAttachmentAttributesResponse creates a response to parse from DescribeInstanceAttachmentAttributes response
func CreateDescribeInstanceAttachmentAttributesResponse() (response *DescribeInstanceAttachmentAttributesResponse) {
	response = &DescribeInstanceAttachmentAttributesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
